<?php
    /*
     CouchCMS
     Copyright(c) 2011 - 2012 kksidd@gmail.com
     
     THIS IS COPYRIGHTED SOFTWARE
     PLEASE READ THE LICENSE AGREEMENT
    */
    
   /****************Adapted from:************************/
   /******************* Stop Forum Spam *****************/
   /************ By Joe Hayes, for ProphpBB.com *********/
   /******************** Version 1.0.5 ******************/
   /*****************************************************/
   
   if ( !defined('K_COUCH_DIR') ) die(); // cannot be loaded directly
   
   class StopForumSpam{
   
      /* Send out an email if someone is rejected? */
      var $send_email		= FALSE; // make it TRUE if you wish to receive an email if a spammer is stopped
      var $email_address	= 'yourmailaddress@whatever.com'; // set this to the account receiving the email

      /* Message to spammer */
      var $message = '<h1>No soup for you!</h1><p>It looks like you\'ve been flagged as a spammer. <em>You may not pass.</em></p>'; 
      
      /*****************************************************/
      /*************** DO NOT MODIFY BELOW *****************/
      /*****************************************************/    

      
      function StopForumSpam(){
         global $FUNCS;
         
         // register custom tag 
         $FUNCS->register_tag( 'stop_spam', array('StopForumSpam', 'stop_spam_handler') ); 
      }
      
      // tag handler
      function stop_spam_handler( $params, $node ){
         global $CTX, $FUNCS, $AUTH, $SFS;
         if( $AUTH->user->access_level >= K_ACCESS_LEVEL_ADMIN ){ return; }
         if( defined('K_PHP_4') ){ return; }
         
         extract( $FUNCS->get_named_vars(
                     array(
                           'username'=>'',
                           'email'=>'',
                           'IP'=>''
                           ),
                     $params)
                );
         $username = trim( $username );
         if( $username=='' ) $username = $CTX->get('frm_k_author'); // get from submitted comment form
         if( $username=='' ) return;
         
         $email = trim( $email );
         if( $email=='' ) $email = $CTX->get('frm_k_email'); // get from submitted comment form
         if( $email=='' ) return;
         
         $IP = trim( $IP );
         if( $IP=='' ) $IP = $_SERVER["REMOTE_ADDR"];
         $IP = preg_replace( '/[^0-9A-F:., ]/i', '', $IP );
         
         $spam_value = $SFS->checkStopForumSpam( $username, $email, $IP );
         // If we've got a spammer we'll take away their soup!
         if( $spam_value >= 3 ){
            if( $SFS->send_email ){
               $from = $to = $SFS->email_address;
               $subject = 'Spam Stopped!';
               $message = "Stopped a spam posting...\n\nUsername: ".$username
               ."\nEmail: ".$email.
               "\nIP: ".$IP.
               "\nScore: ".$spam_value;
               
               $FUNCS->send_mail( $from, $to, $subject, $message );
            }
            
            // Let's kill the posting process with a nice little message
            ob_end_clean();
            die( $SFS->message );
         }
      }

      // Where the good stuff happens
      function checkStopForumSpam($username, $email, $ip){
         global $FUNCS;
         
         // Default value
         $spam_score = 0;
         
         // Query the SFS database and pull the data into script
         $xmlUrl = 'http://www.stopforumspam.com/api?username='.urlencode($username).'&ip='.urlencode($ip).'&email='.urlencode($email).'&f=xmldom';
         $xmlStr = $FUNCS->file_get_contents($xmlUrl);
         
         // Check if user is a spammer, but only if we successfully got the SFS data
         if ($xmlStr) {
            $xmlObj = @simplexml_load_string($xmlStr);
            $arrXml = $this->objectsIntoArray($xmlObj);
            
            // Assign points for the total number of times each have been flagged
            $ck_username = $arrXml['username']['frequency'];
            $ck_email = $arrXml['email']['frequency'];
            $ck_ip = $arrXml['ip']['frequency'];
            
            // Let's not ban a registrant with a common username, who is otherwise clean
            if ($ck_email + $ck_ip == 0) {
               $ck_username = 0;
            }
            
            // Let's not ban a registrant with a common IP address, who is otherwise clean
            if ($ck_username + $ck_email == 0) {
               $ck_ip = 0;
            }
            
            // Return the total score
            $spam_score = ($ck_username + $ck_email + $ck_ip);
         }
         
         return $spam_score;
      }      

      // Turns object results into an array, from http://www.stopforumspam.com/apiscode
      function objectsIntoArray($arrObjData, $arrSkipIndices = array()){
         $arrData = array();
         
         if (is_object($arrObjData)) {
            $arrObjData = get_object_vars($arrObjData);
         }
         
         if (is_array($arrObjData)) {
            foreach ($arrObjData as $index => $value) {
               if (is_object($value) || is_array($value)) {
                  $value = $this->objectsIntoArray($value, $arrSkipIndices);
               }
               if (in_array($index, $arrSkipIndices)) {
                  continue;
               }
               $arrData[$index] = $value;
            }
         }
         return $arrData;
      }
      
   } // end class
   
   $SFS = new StopForumSpam();

  
   